Bug 252182 - audio/gvolwheel: causes xorg-server crash
Summary: audio/gvolwheel: causes xorg-server crash
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: --- Affects Some People
Assignee: Alexey Dokuchaev
URL: https://github.com/Junker/gvolwheel/i...
Keywords:
Depends on:
Blocks:
 
Reported: 2020-12-27 03:38 UTC by rozhuk.im
Modified: 2021-03-02 08:29 UTC (History)
3 users (show)

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description rozhuk.im 2020-12-27 03:38:46 UTC
==========================================================
Found core: /tmp/Xorg.00.core.gz
Unpacking...done
App file name: /usr/local/bin/Xorg
Command line: /usr/local/bin/Xorg -nolisten tcp -to 5 vt09 -auth /var/run/slim.auth
Env: XAUTHORITY=/var/run/slim.auth DISPLAY=unix:0.0 PATH=/sbin:/bin:/usr/sbin:/usr/bin PWD=/ HOME=/ RC_PID=35

Resource usage
  PID COMM             RESOURCE                          VALUE        
92359 Xorg             user time                    00:00:25.964263   
92359 Xorg             system time                  00:00:07.685421   
92359 Xorg             maximum RSS                           506440 KB
92359 Xorg             integral shared memory               6705008 KB
92359 Xorg             integral unshared data                625804 KB
92359 Xorg             integral unshared stack               939648 KB
92359 Xorg             page reclaims                          94990   
92359 Xorg             page faults                             1306   
92359 Xorg             swaps                                      0   
92359 Xorg             block reads                              832   
92359 Xorg             block writes                               0   
92359 Xorg             messages sent                         858334   
92359 Xorg             messages received                     491151   
92359 Xorg             signals received                         920   
92359 Xorg             voluntary context switches            831592   
92359 Xorg             involuntary context switches            1271   

(lldb) target create "/usr/local/bin/Xorg" --core "/tmp/Xorg.00.core"
Core file '/tmp/Xorg.00.core' (x86_64) was loaded.
(lldb) bt all
* thread #1, name = 'MainThread', stop reason = signal SIGABRT
  * frame #0: 0x0000000800a3e41a libc.so.7`__sys_thr_kill + 10
    frame #1: 0x0000000800a3c664 libc.so.7`__raise + 52
    frame #2: 0x00000008009b620c libc.so.7`abort + 76
    frame #3: 0x000000000043762a Xorg`OsAbort + 26
    frame #4: 0x000000000043f02c Xorg`___lldb_unnamed_symbol2798$$Xorg + 76
    frame #5: 0x000000000043cfaa Xorg`FatalError + 266
    frame #6: 0x0000000000434c98 Xorg`___lldb_unnamed_symbol2707$$Xorg + 168
    frame #7: 0x0000000800874db5 libthr.so.3`___lldb_unnamed_symbol101$$libthr.so.3 + 229
    frame #8: 0x000000080087432f libthr.so.3`___lldb_unnamed_symbol82$$libthr.so.3 + 319
    frame #9: 0x00007fffffffe173
    frame #10: 0x00000000002a9a6e Xorg`WindowHasNewCursor + 62
    frame #11: 0x00000000002d048b Xorg`ChangeWindowAttributes + 4651
    frame #12: 0x0000000000294b74 Xorg`___lldb_unnamed_symbol67$$Xorg + 148
    frame #13: 0x000000000029410a Xorg`___lldb_unnamed_symbol64$$Xorg + 730
    frame #14: 0x000000000029ef1c Xorg`___lldb_unnamed_symbol176$$Xorg + 1100
    frame #15: 0x00000000002865d5 Xorg`_start + 261
  thread #2, name = 'InputThread', stop reason = signal SIGABRT
    frame #0: 0x00000008009e700a libc.so.7`__sys_poll + 10
    frame #1: 0x0000000800871bb6 libthr.so.3`___lldb_unnamed_symbol38$$libthr.so.3 + 54
    frame #2: 0x00000000004350bc Xorg`___lldb_unnamed_symbol2714$$Xorg + 28
    frame #3: 0x0000000000432b3c Xorg`___lldb_unnamed_symbol2695$$Xorg + 540
    frame #4: 0x000000080086f082 libthr.so.3`___lldb_unnamed_symbol1$$libthr.so.3 + 354
==========================================================

Have no idea why, but this start after I update and reboot system, uptime was 60+ days, so I think possible https://github.com/freebsd/freebsd-ports/commit/5cbe8e0919300fa6cef919b904563f600a759619#diff-89483bd03fc72635243b6754a6855fc1cd37ea69b0d08ba007de22b395c069b3 or some other changes in other ports.

Xorg crash on left click or after some time after gvolwheel started.
Comment 1 rozhuk.im 2020-12-27 04:52:32 UTC
I check with some outdated FreeBSD at VBox, latest gvolwheel even with virtual_oss - ok.

List of outdated ports:
alsa-plugins-1.1.1_6               <   needs updating (index has 1.1.1_7)
aom-2.0.0_1                        <   needs updating (index has 2.0.1_1)
automake-1.16.2                    <   needs updating (index has 1.16.3)
bash-5.0.18_3                      <   needs updating (index has 5.1.4)
ccache-3.7.1_2                     >   succeeds index (index has 3.7.1_1)
chromium-85.0.4183.121_2           <   needs updating (index has 87.0.4280.88)
claws-mail-3.17.5_4                <   needs updating (index has 3.17.8)
claws-mail-address_keeper-3.17.5   <   needs updating (index has 3.17.8)
claws-mail-mailmbox-3.17.5         <   needs updating (index has 3.17.8)
claws-mail-notification-3.17.5     <   needs updating (index has 3.17.8)
cmake-3.18.4                       <   needs updating (index has 3.18.5)
curl-7.73.0                        <   needs updating (index has 7.74.0)
dav1d-0.7.1                        <   needs updating (index has 0.8.0)
dino-0.1.0.20201007_1              <   needs updating (index has 0.2.0)
drm-fbsd12.0-kmod-4.16.g20200221   <   needs updating (index has 4.16.g20201016)
evince-lite-3.36.7_3               <   needs updating (index has 3.38.0_1)
expat-2.2.8                        <   needs updating (index has 2.2.10)
ffmpeg-4.3.1_5,1                   <   needs updating (index has 4.3.1_9,1)
firefox-83.0,2                     <   needs updating (index has 84.0.1,2)
freerdp-2.2.0_2                    <   needs updating (index has 2.2.0_3)
fusefs-libs3-3.10.0_1              <   needs updating (index has 3.10.1_1)
fusefs-sshfs-3.7.0_1               <   needs updating (index has 3.7.1)
gdb-9.2_2                          <   needs updating (index has 10.1)
geeqie-1.5.1_12                    <   needs updating (index has 1.6_1)
ghostscript9-agpl-base-9.52_11     <   needs updating (index has 9.52_12)
glib-2.66.2,1                      <   needs updating (index has 2.66.4_1,1)
gmp-6.2.0                          <   needs updating (index has 6.2.1)
gnome-calculator-3.38.1            <   needs updating (index has 3.38.2_1)
gpu-firmware-kmod-g20200920        <   needs updating (index has g20201213)
graphviz-2.44.1_4                  <   needs updating (index has 2.44.1_5)
greybird-theme-3.22.12_1           <   needs updating (index has 3.22.13)
gspell-1.8.4                       <   needs updating (index has 1.9.1)
gtk-update-icon-cache-3.24.20      <   needs updating (index has 3.24.24)
gtk2-2.24.32                       <   needs updating (index has 2.24.33)
gtk3-3.24.23_2                     <   needs updating (index has 3.24.24)
i386-wine-devel-5.8_1,1            <   needs updating (index has 6.0.r3_1,1)
icu-68.1,1                         <   needs updating (index has 68.2,1)
jasper-2.0.22                      <   needs updating (index has 2.0.23)
jpeg-turbo-2.0.5                   <   needs updating (index has 2.0.6)
kodi-devel-19.0.a20201006          >   succeeds index (index has 19.0.a20200727_4)
libfmt-7.0.3                       <   needs updating (index has 7.1.3)
libilbc-2.0.2                      <   needs updating (index has 3.0.3)
libinput-1.16.2                    <   needs updating (index has 1.16.4)
liblz4-1.9.2_1,1                   <   needs updating (index has 1.9.3,1)
libnghttp2-1.41.0                  <   needs updating (index has 1.42.0)
libpeas-1.22.0                     <   needs updating (index has 1.26.0)
libressl-3.2.2                     <   needs updating (index has 3.2.3)
libv4l-1.18.0                      <   needs updating (index has 1.20.0)
libva-2.9.1                        <   needs updating (index has 2.10.0)
libva-utils-2.9.1                  <   needs updating (index has 2.10.0)
libxkbcommon-1.0.1                 <   needs updating (index has 1.0.3)
libxml2-2.9.10_1                   <   needs updating (index has 2.9.10_2)
mesa-libs-20.2.0_1                 <   needs updating (index has 20.2.3)
mpg123-1.26.3                      <   needs updating (index has 1.26.4)
mpv-0.32.0_5,1                     <   needs updating (index has 0.33.0_4,1)
ninja-1.10.1,2                     <   needs updating (index has 1.10.2,2)
nss-3.58_1                         <   needs updating (index has 3.60)
openssh-portable-8.2.p1_2,1        <   needs updating (index has 8.4.p1_3,1)
p11-kit-0.23.21                    <   needs updating (index has 0.23.22)
p5-URI-1.76                        <   needs updating (index has 5.05)
pciids-20200922                    <   needs updating (index has 20201127)
pcre2-10.35                        <   needs updating (index has 10.36)
perl5-5.32.0                       <   needs updating (index has 5.32.0_1)
pkg-1.15.10                        <   needs updating (index has 1.16.1)
poppler-20.11.0                    <   needs updating (index has 20.12.1)
poppler-glib-20.11.0               <   needs updating (index has 20.12.1)
portmaster-3.19_26                 <   needs updating (index has 3.19_27)
py37-libxml2-2.9.10_1              <   needs updating (index has 2.9.10_2)
qt5-buildtools-5.15.0              <   needs updating (index has 5.15.2_1)
qt5-core-5.15.0_4                  <   needs updating (index has 5.15.2)
qt5-dbus-5.15.0                    <   needs updating (index has 5.15.2_1)
qt5-gui-5.15.0_1                   <   needs updating (index has 5.15.2_2)
qt5-network-5.15.0                 <   needs updating (index has 5.15.2_1)
qt5-widgets-5.15.0                 <   needs updating (index has 5.15.2_1)
rar-5.9.1,3                        <   needs updating (index has 6.0.b2,3)
rust-1.47.0                        <   needs updating (index has 1.48.0)
rust-cbindgen-0.15.0_1             <   needs updating (index has 0.15.0_2)
spdlog-1.8.1                       <   needs updating (index has 1.8.2)
spidermonkey78-78.4.0              <   needs updating (index has 78.4.0_1)
sqlite3-3.33.0_1,1                 <   needs updating (index has 3.34.0,1)
stixfonts-2.0.2                    <   needs updating (index has 2.10)
svt-av1-0.8.5                      <   needs updating (index has 0.8.6)
tcl86-8.6.10                       <   needs updating (index has 8.6.10_1)
unrar-5.91,6                       <   needs updating (index has 6.00.beta2,6)
upower-0.99.11                     <   needs updating (index has 0.99.11_1)
v4l_compat-1.18.0                  <   needs updating (index has 1.20.0)
vulkan-headers-1.2.135.0           <   needs updating (index has 1.2.165)
webcamd-5.7.1.1_1                  <   needs updating (index has 5.10.6.0)
wget-1.20.3                        <   needs updating (index has 1.20.3_1)
x265-3.4                           <   needs updating (index has 3.4_1)
xf86-video-intel-2.99.917.909,1    <   needs updating (index has 2.99.917.914,1)
xfce4-diskperf-plugin-2.6.2_1      <   needs updating (index has 2.6.3)
xfce4-mount-plugin-1.1.3_1         <   needs updating (index has 1.1.4)
xfce4-notifyd-0.6.2                <   needs updating (index has 0.6.2_1)
xfce4-screenshooter-plugin-1.9.7   <   needs updating (index has 1.9.8)
xfce4-settings-4.14.3              <   needs updating (index has 4.14.3_1)
xfce4-terminal-0.8.9.2             <   needs updating (index has 0.8.10)
xfce4-tumbler-0.2.9_5              <   needs updating (index has 0.2.9_6)
xfce4-wm-4.14.6                    <   needs updating (index has 4.14.6_2)
xfce4-xkb-plugin-0.8.1_3           <   needs updating (index has 0.8.2)
xkbcomp-1.4.3                      <   needs updating (index has 1.4.4)
xorg-server-1.20.9,1               <   needs updating (index has 1.20.9_1,1)
xprop-1.2.4                        <   needs updating (index has 1.2.5)
youtube_dl-2020.11.01.1            <   needs updating (index has 2020.12.26)


After update I got gvolwheel crash:
==========================================================
Found core: /tmp/gvolwheel.00.core.gz
Unpacking...done
App file name: /usr/local/bin/gvolwheel
Command line: gvolwheel
Env: PANEL_GDK_CORE_DEVICE_EVENTS=0 SSH_AGENT_PID=34969 SSH_AUTH_SOCK=/tmp/ssh-bKWg4d3B4ORk/agent.34877 SESSION_MANAGER=local/rimwksv:/tmp/.ICE-unix/32063 DBUS_SESSION_BUS_ADDRESS=unix:path=/tmp/dbus-uCe8hvU9S4,guid=9ed6eac2b3d43fe41cbf3c585fe81263 VENDOR=amd LOGNAME=rim LANG=en_US.UTF-8 PAGER=more OSTYPE=FreeBSD MACHTYPE=x86_64 FTP_PASSIVE_MODE=YES XAUTHORITY=/home/rim/.Xauthority MAIL=/var/mail/rim PATH=/sbin:/bin:/usr/sbin:/usr/bin:/usr/local/sbin:/usr/local/bin:/usr/games:/home/rim/bin EDITOR=ee HOST=rimwksv QT_STYLE_OVERRIDE=gtk PWD=/home/rim GROUP=rim TERM=xfce4-terminal GTK_OVERLAY_SCROLLING=0 USER=rim HOME=/home/rim TZ=:/etc/localtime HOSTTYPE=FreeBSD SHELL=/bin/csh XDG_SESSION_COOKIE=rimwksv-1609044579.614323-1779741210 BLOCKSIZE=K SHLVL=1 DISPLAY=unix:0.0 DESKTOP_STARTUP_ID=xfce4-panel/gvolwheel/68798-0-rimwksv_TIME88036

Resource usage
  PID COMM             RESOURCE                          VALUE        
18252 gvolwheel        user time                    00:00:00.114366   
18252 gvolwheel        system time                  00:00:00.043986   
18252 gvolwheel        maximum RSS                            33228 KB
18252 gvolwheel        integral shared memory                   216 KB
18252 gvolwheel        integral unshared data                   144 KB
18252 gvolwheel        integral unshared stack                 2304 KB
18252 gvolwheel        page reclaims                           1556   
18252 gvolwheel        page faults                                0   
18252 gvolwheel        swaps                                      0   
18252 gvolwheel        block reads                                8   
18252 gvolwheel        block writes                               0   
18252 gvolwheel        messages sent                            403   
18252 gvolwheel        messages received                        544   
18252 gvolwheel        signals received                           0   
18252 gvolwheel        voluntary context switches               502   
18252 gvolwheel        involuntary context switches               2   

(lldb) target create "/usr/local/bin/gvolwheel" --core "/tmp/gvolwheel.00.core"
Core file '/tmp/gvolwheel.00.core' (x86_64) was loaded.
(lldb) bt all
* thread #1, name = 'gvolwheel', stop reason = signal SIGBUS
  * frame #0: 0x00000000002059ca gvolwheel`vol_window_show + 42
    frame #1: 0x0000000000206afd gvolwheel`on_tray_icon_press + 29
    frame #2: 0x0000000800c26451 libgtk-3.so.0`___lldb_unnamed_symbol10465$$libgtk-3.so.0 + 113
    frame #3: 0x0000000801056e78 libgobject-2.0.so.0`g_closure_invoke(closure=0x0000000802ab9ba0, return_value=0x00007fffffffc440, n_param_values=2, param_values=0x00007fffffffc470, invocation_hint=0x00007fffffffc428) at gclosure.c:810:7
    frame #4: 0x000000080107a36f libgobject-2.0.so.0`signal_emit_unlocked_R(node=0x0000000802a76700, detail=0, instance=0x00000008023d9030, emission_return=0x00007fffffffc8e8, instance_and_params=0x00007fffffffc470) at gsignal.c:3738:8
    frame #5: 0x000000080107c09c libgobject-2.0.so.0`g_signal_emit_valist(instance=0x00000008023d9030, signal_id=161, detail=0, var_args=0x00007fffffffcb40) at gsignal.c:3504:7
    frame #6: 0x000000080107c8cf libgobject-2.0.so.0`g_signal_emit(instance=0x00000008023d9030, signal_id=161, detail=0) at gsignal.c:3550:3
    frame #7: 0x0000000800853cfe libgtk-3.so.0`___lldb_unnamed_symbol1265$$libgtk-3.so.0 + 62
    frame #8: 0x0000000800c26451 libgtk-3.so.0`___lldb_unnamed_symbol10465$$libgtk-3.so.0 + 113
    frame #9: 0x0000000801056e78 libgobject-2.0.so.0`g_closure_invoke(closure=0x0000000802aba730, return_value=0x00007fffffffce80, n_param_values=2, param_values=0x00007fffffffceb0, invocation_hint=0x00007fffffffce68) at gclosure.c:810:7
    frame #10: 0x000000080107a36f libgobject-2.0.so.0`signal_emit_unlocked_R(node=0x000000080238dc20, detail=0, instance=0x0000000802aa04b0, emission_return=0x00007fffffffd328, instance_and_params=0x00007fffffffceb0) at gsignal.c:3738:8
    frame #11: 0x000000080107c09c libgobject-2.0.so.0`g_signal_emit_valist(instance=0x0000000802aa04b0, signal_id=60, detail=0, var_args=0x00007fffffffd580) at gsignal.c:3504:7
    frame #12: 0x000000080107c8cf libgobject-2.0.so.0`g_signal_emit(instance=0x0000000802aa04b0, signal_id=60, detail=0) at gsignal.c:3550:3
    frame #13: 0x0000000800bc6e89 libgtk-3.so.0`___lldb_unnamed_symbol9628$$libgtk-3.so.0 + 953
    frame #14: 0x0000000800a2c52f libgtk-3.so.0`gtk_propagate_event + 255
    frame #15: 0x0000000800a2c111 libgtk-3.so.0`gtk_main_do_event + 2369
    frame #16: 0x00000008002baeb4 libgdk-3.so.0`___lldb_unnamed_symbol146$$libgdk-3.so.0 + 52
    frame #17: 0x00000008002f8127 libgdk-3.so.0`___lldb_unnamed_symbol644$$libgdk-3.so.0 + 39
    frame #18: 0x000000080118ac52 libglib-2.0.so.0`g_main_dispatch(context=0x000000080239b300) at gmain.c:3325:27
    frame #19: 0x000000080118aa80 libglib-2.0.so.0`g_main_context_dispatch(context=0x000000080239b300) at gmain.c:4043:7
    frame #20: 0x000000080118aff2 libglib-2.0.so.0`g_main_context_iterate(context=0x000000080239b300, block=1, dispatch=1, self=0x0000000802c8b2c0) at gmain.c:4119:5
    frame #21: 0x000000080118b538 libglib-2.0.so.0`g_main_loop_run(loop=0x0000000802c648b0) at gmain.c:4317:5
    frame #22: 0x0000000800a2b65b libgtk-3.so.0`gtk_main + 75
    frame #23: 0x0000000000205725 gvolwheel`main + 261
    frame #24: 0x00000000002053f5 gvolwheel`_start + 261
==========================================================
Comment 2 Alexey Dokuchaev freebsd_committer 2020-12-28 05:50:39 UTC
I couldn't reproduce xorg-server crash with either gtk3 3.24.20 or 3.24.24 on IceWM 1.9.2; however, while making some random clicks, it once did crash due to the assertion:

> (gvolwheel:14782): Gtk-CRITICAL **: 12:51:10.533: gtk_window_set_accept_focus:
> assertion 'GTK_IS_WINDOW (window)' failed
I'm not sure if I want to install Xfre, but I'll try some other lightweight window managers and panels/trays.
Comment 3 rozhuk.im 2020-12-28 05:57:02 UTC
I can not reproduce crash in VBox too.

I spent some time to rewrite app: https://github.com/rozhuk-im/gvolwheel/tree/refactor %)
Comment 4 rozhuk.im 2020-12-28 07:55:32 UTC
https://github.com/Junker/gvolwheel/pull/3
This fixes crashes for me, and does no requires patch files for port.
Comment 5 Alexey Dokuchaev freebsd_committer 2020-12-28 08:43:38 UTC
(In reply to rozhuk.im from comment #4)
Thanks, I'll try to get this committed tonight.  Would you also like to take maintainership of the port?
Comment 6 Alexey Dokuchaev freebsd_committer 2020-12-28 10:03:36 UTC
(In reply to rozhuk.im from comment #4)
>  SIZE (Junker-gvolwheel-1.0.2_GH0.tar.gz) = 16277
>  ...
> +SIZE (94cee9010bf47d32e8280a76a1354e88d79a6a30.patch) = 68415
The diff is actually quite noisy and four times larger than the tarball.  I'd say that's a bit too much for a crash fix. :-)  Would it be possible to shepherd the patch with upstream maintainer and persuade him to release a new version?
Comment 7 rozhuk.im 2020-12-28 10:14:07 UTC
(In reply to Alexey Dokuchaev from comment #5)

https://github.com/rozhuk-im/freebsd-ports/commit/4f87205f44e53b2acbab1f2de6219965d2738985
patch to ports.


Yes, I see there is no maintainer.


(In reply to Alexey Dokuchaev from comment #6)

I am waiting for upstream reply.

https://github.com/Junker/gvolwheel/pull/2 - this should fix crash only, I test it only in VBox.
Comment 8 Alexey Dokuchaev freebsd_committer 2021-03-02 08:22:57 UTC
As of ports r566240, the port had been updated to version 1.0.3 which apparently includes the crash fix.  Could you confirm so we can close this PR?
Comment 9 rozhuk.im 2021-03-02 08:29:14 UTC
Yes, updated version includes first simple fix.
PR with big refactoring is still waiting for author response.